﻿// -----------------------------------------------------------------------------------------
// <copyright file="WebHeaderCollectionExtensions.cs" company="Microsoft">
//    Copyright 2012 Microsoft Corporation
// 
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// 
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.
// </copyright>
// -----------------------------------------------------------------------------------------

namespace Microsoft.WindowsAzure.Storage.Shared.Protocol
{
    using System.Net;

    internal static class WebHeaderCollectionExtensions
    {
        internal static void Add(this WebHeaderCollection col, string name, string value)
        {
            string existingValue = col[name];

            value = value ?? string.Empty;

            // We should not check for IsNullOrEmpty here, since empty header is a valid value
            if (existingValue == null)
            {
                col[name] = value.Trim();
            }
            else
            {
                col[name] = string.Concat(existingValue, ",", value.Trim());
            }
        }
    }
}
